from pynput import keyboard
import os
import subprocess
import typer
import time

ptt_key = 269025026
TALKING = False


def get_desc(keycode):
    hex_code = f"{keycode:#0{6}x}"
    try:
        s = subprocess.check_output(
            f"xmodmap -pk | grep '{hex_code}'",
            shell=True,
        )
        return s.decode().split("\t")[1]
    except:
        return "<unknown key>"


def unmute():
    global TALKING
    if TALKING:
        return
    else:
        TALKING = True

    print("unmute")
    os.system("pactl set-source-mute @DEFAULT_SOURCE@ false")


def mute():
    global TALKING
    TALKING = False
    print("mute")
    os.system("pactl set-source-mute @DEFAULT_SOURCE@ true")


def on_press(key):
    if hasattr(key, "vk") and key.vk == ptt_key:
        unmute()


def on_release(key):
    if hasattr(key, "vk") and key.vk == ptt_key:
        mute()


def fetch_keycode(key):
    if key == keyboard.Key.esc:
        return False
    if hasattr(key, "vk"):
        print(f"Keycode {get_desc(key.vk)}")


app = typer.Typer()


@app.command()
def get_keycode():
    print("Listending for keycodes, press esc to exit")
    listener = keyboard.Listener(on_press=fetch_keycode)
    listener.start()  # start to listen on a separate thread
    listener.join()  # remove if main thread is polling self.keys


@app.command()
def ptt(keycode=None):
    global ptt_key
    if keycode:
        ptt_key = int(keycode, 16)
    listener = keyboard.Listener(
        on_press=on_press,
        on_release=on_release,
    )
    print(f"Binding PTT key: {get_desc(ptt_key)}")
    listener.start()  # start to listen on a separate thread
    listener.join()  # remove if main thread is polling self.keys


if __name__ == "__main__":
    app()
